#include "common.h"

static	int	header_out(), putenc0(), putenc1();
static	void	*putenc_fn[], *putcfill_fn[];
static	void	notcom2t();

static	int	pos, length;
static	int	(*putenc)(), (*putcfill)();

static	int	encnewsub(buf, isize, otf)
int	*buf, isize;
register FILE	*otf;
{
	int	t = 0, i, osize;

	for(i = 0; i < 4; i++) t *= 3, t += buf[i] % 3;
	osize = putenc((t + 1) * 20 / 19, otf);
	for(i = 0; i < isize; i++) osize += putenc(buf[i] / 3, otf);
	return osize;
}

void	encode(inf, inchar1, inchar2, otf, len, enctype)
FILE	*inf;
register FILE	*otf;
int	len, inchar1, inchar2, enctype;
{
	register int	c;
	register char	i = 0, j = 2;
	long	osize;
	static	lastchar[] = {':', '=', '*'};

	putenc = (int (*)())putenc_fn[enctype];
	putcfill = (int (*)())putcfill_fn[enctype == ENC_NEWCOMSH];

	osize = (long)header_out(otf, enctype);
	length = len;
	if(pos >= length) (putc('\n', otf), osize += 2, pos = 0);

	if(enctype == ENC_NEWCOMSH){
		int	buf[4];

		while(c = j ? (--j ? inchar1 : inchar2) : getc(inf), c != EOF){
			buf[i++] = c;
			if(i == 4){
				osize += (long)encnewsub(buf, i, otf);
				i = 0;
			}
		}
		if(i) osize += (long)encnewsub(buf, i, otf);
	} else {
		int	t = 0;

		while(c = j ? (--j ? inchar1 : inchar2) : getc(inf), c != EOF){
			switch(i++){
			case 0:
				osize += (long)putenc(c >> 2, otf);
				t = c << 4;
				break;
			case 1:
				osize += (long)putenc((c >> 4) | t, otf);
				t = c << 2;
				break;
			default:
				osize += (long)putenc((c >> 6) | t, otf);
				osize += (long)putenc(c, otf);
				i = 0;
				break;
			}
		}
		if(i) osize += (long)putenc(t, otf);
	}

	osize += (long)putcfill(lastchar[enctype], otf);
	if(pos) (putc('\n', otf), osize += 2);
#ifdef DEBUG
	fprintf(stderr, "output %ld bytes\n", osize);
#endif
	if(osize > MAXOSIZE){
		fputs("Warning: output is too big, so it may works incorrectly\n",
		      stderr);
	}
}

static	int	putenc2(c, otf)
register int	c;
register FILE	*otf;
{
	if((c += '!') >= '*') ++c;
	return putcfill(c, otf);
}

static	int	putenc1(c, otf)
register int	c;
register FILE	*otf;
{
	if((c &= 0x3f) != 0x3f) c += 0x40;
	return putcfill(c, otf);
}

static	int	putenc0(c, otf)
register int	c;
register FILE	*otf;
{
	c &= 0x3f, c += 0x40;
	if('Z' < c && c < 'a' && c != '_') c = '.' + '`' - c;
	else
	if('z' < c || c < 'A') c = ('4' + '@' - c) & 0x3f;

	return putcfill(c, otf);
}

static	void	*putenc_fn[] = {
	(void *)putenc0,
	(void *)putenc1,
	(void *)putenc2,
};

static	int	putcfill0(c, otf)
register int	c;
register FILE	*otf;
{
	putc(c, otf);
	if(++pos >= length){
		putc('\n', otf), pos = 0;
		return 3; /* 1 for c, 2 for "\r\n" */
	} else return 1;
}

static	int	putcfill1(c, otf)
register int	c;
register FILE	*otf;
{
	c = putcfill0(c, otf);
	if(!pos) putc(':', otf), ++pos, ++c;
	return c;
}

static	void	*putcfill_fn[] = {
	(void *)putcfill0,
	(void *)putcfill1,
};

static	void	ldout(l, f)
unsigned long	l;
FILE	*f; /* output long integer to file */
{
	int	c;

	c = (int)(l % 10L), l /= 10L;
	if(l) ldout(l, f);
	putc(c + '0', f);
}

static	int	header_out(otf, enctype)
FILE	*otf;
int	enctype;
{
	extern	char	**comtdat[];
	register char	**pp, *p;
	int	retsize = 0, l;

	for(pp = comtdat[enctype]; ; pp++){
		if(enctype != ENC_ECHOABLE && pp[1] == NULL){
			fputs("  --- Insert lines here. File size must be <=",
			      otf);
			ldout(MAXOSIZE, otf);
			fputs(" bytes.\n", otf);
			 /* ̕͏o̓f[^TCYɐĂȂ */
		}
		fputs(p = *pp, otf);
		retsize += (l = strlen(p));
		if(l && p[l - 1] == '\n') retsize++;
		 /* '\n'̓f[^̍ŌɂȂƂOƂ */
		if(pp[1] == NULL){
			pos = l;
			return retsize;
		}
	}
}

static	int	alltxt(s) /* '\n' '\r'΂肩Ȃ镶Ȃ0 */
char	*s;
{
	int	c;

	for(; (c = *s) != '\0'; s++){
		if(!is_print(c) && c != '\n' && c != '\r') return 0;
	}
	return 1;
}

static	int	endeol(s)
char	*s;
{
	return *s && (*(s += strlen(s), --s) == '\n' || *s == '\r');
}

static	char	*rfgets(s, n, f) /* PƂ\rsƌȂfgets */
char	*s;
int	n;
FILE	*f;
{
	int	c, i;

	for(--n, i = 0; i < n; ){
		c = getc(f);
		if(c == EOF){
			if(i) break;
			return NULL;
		}
		s[i++] = c;
		if(c == '\r'){
			if(EOF == (c = getc(f))) break;
			ungetc(c, f);
			if(c != '\n') break;
		} else
		if(c == '\n') break;
	}
	s[i] = '\0';
	return s;
}

void	decode(inf, otf)
FILE	*inf;
register FILE	*otf;
 /*
  OƂtH[}bg:
     echo\`̏ꍇ
	wb_
		1s ("TXPPP"  "T_OOWW3=") + eLXgf[^
		  ("TXPPP" ͋o[Ŵ)
		2s QSTRLEÑeLXgf[^ + eLXgf[^
		wb_̍Ō 2sڂ̐擪QSTRLENoCgōŏ
			     "__" oƂ
	encodeꂽf[^
		eLXg (':'ŏI o[W'='ŏI)
     com-batchp`ł̏ꍇ
	wb_
		1s ":=%00%AA" + eLXgf[^
		2s QSTRLEÑeLXgf[^ + eLXgf[^
		wb_̍Ō 2sڂ̐擪QSTRLENoCgōŏ "##"
			     oƂ(܂ł̊es ":" Ŏn܂)
			     + s + Cӂ̃f[^ + s + "*"
	encodeꂽf[^
		eLXg (':'ŏI ܂ł'='͏oĂȂ͂)
     com-batchp`ł̏ꍇ
	wb_
  		1s eLXg2 + "7%00%AAP" + eLXgf[^
		2s QSTRLEÑeLXgf[^ + eLXgf[^
		wb_̍Ō 2sڂ̐擪QSTRLENoCgōŏ "##"
			     oƂ̒2 + Cӂ̃f[^ +
			     s + Ɠ2
	encodeꂽf[^
		eLXg ('='ŏI) AR[h0x3d͖̕
     com-batchp`̏ꍇ
	wb_
  		1s eLXg2 + "7%00%CCP" + eLXgf[^
  		 (1O̔łł eLXg2 + "7%00%BBP" + eLXgf[^)
		2s QSTRLEÑeLXgf[^ + eLXgf[^
		wb_̍Ō 2sڂ̐擪QSTRLENoCgōŏ"N"6
			     oƂ̒2 + Cӂ̃f[^ +
			     s + Ɠ2
	encodeꂽf[^
		eLXg ('='ŏI) AR[h0x3d͖̕
     Vcom-batchp`̏ꍇ
	wb_
  		1s eLXg2 + "7%00%DDP" + eLXgf[^
		2s QSTRLEÑeLXgf[^ + eLXgf[^
		wb_̍Ō 2sڂ̐擪QSTRLENoCgōŏ"N"6
			     oƂ̒2 + Cӂ̃f[^ +
			     s + Ɠ2
	encodeꂽf[^
		eLXg ('*'ŏI) Aes͖
     ̏ꍇ^u͊܂܂Ȃ wb_1sڂ̒MAXHLENȉ̂
     com-batchp`(TYPE_COMSHPREVȍ~)̏ꍇs\n \r\n̑ \r
     Ƃ
 */
{
#define MAXHLEN 80
#define SEE0 8
#define SEE1 8 /* Ƃ肠8̂܂܂ɂƂ */

	extern	char	**comtdat[];
	static	char	oldh0[] = {'T', 'X', 'P', 'P', 'P'};
	static	char	oldh1[] = {':', '=', '%', '0', '0', '%', 'A', 'A'};
	static	char	oldh2[] = {'7', '%', '0', '0', '%', 'A', 'A', 'P'};
	static	char	oldh3[] = {'7', '%', '0', '0', '%', 'B', 'B', 'P'};
	char	buf[MAXHLEN + 3]; /* text + "\r\n\0" */
	register int	c, t = 0;
	int	prevc, tagcnt, enctype;
	char	i;

	struct {
		char	ch;
		int	cnt;
	} endtag[] = {
		{ '_', 2 }, /* TYPE_ECHOABLE */
		{ 'N', 6 }, /* TYPE_COMSHARE */
		{ 'N', 4 }, /* TYPE_COMSHPREV */
		{ '#', 2 }, /* TYPE_COMSHOLD */
		{ '#', 2 }, /* TYPE_COMSHOOLD */
		{ 'N', 6 }, /* TYPE_NEWCOMSH */
	};

	for(;;){
		if(NULL == rfgets(buf, MAXHLEN + 3, inf)) notcom2t();
		if(!endeol(buf)){
			for(;;){
				if(NULL == rfgets(buf, MAXHLEN + 3, inf))
					notcom2t();
				if(endeol(buf)) break;
			}				
			continue;
		} else
		if(!alltxt(buf)) continue;

		if(!strncmp(comtdat[ENC_ECHOABLE][0], buf, SEE0) ||
		   !strncmp(oldh0, buf, sizeof(oldh0))){
			enctype = TYPE_ECHOABLE;
		} else
		if(!strncmp(oldh1, buf, sizeof(oldh1))){
			enctype = TYPE_COMSHOOLD;
		} else
		if(!strncmp(oldh2, buf + 2, sizeof(oldh2))){
			enctype = TYPE_COMSHOLD;
		} else
		if(!strncmp(oldh3, buf + 2, sizeof(oldh3))){
			enctype = TYPE_COMSHPREV;
		} else
		if(!strncmp(comtdat[ENC_COMSHARE][0] + 2, buf + 2, SEE1)){
			enctype = TYPE_COMSHARE;
		} else
		if(!strncmp(comtdat[ENC_NEWCOMSH][0] + 2, buf + 2, SEE1)){
			enctype = TYPE_NEWCOMSH;
		} else continue;
		break;
	}
		
	if(NULL == fgets(buf, QSTRLEN + 1, inf) || !alltxt(buf) || endeol(buf))
		notcom2t();

	for(prevc = '\0', tagcnt = 0; ;){
		c = getc(inf);
		if(!is_print(c) && c != '\r' && c != '\n' ||
		   enctype == TYPE_COMSHOOLD && prevc == '\n' && c != ':')
			notcom2t();
		if(c == endtag[enctype] . ch){
			if(++tagcnt == endtag[enctype] . cnt) break;
		} else tagcnt = 0;
		prevc = c;
	}

	switch(enctype){
	case TYPE_ECHOABLE:
		break;
	case TYPE_COMSHOOLD:
		for(;;){
			while((c = getc(inf)) != '\n'){
				if(EOF == c) notcom2t();
			}
			if((c = getc(inf)) != '*'){
				if(EOF == c) notcom2t();
				ungetc(c, inf);
			} else break;
		}
		break;
	default:
		for(i = 0; i < 2; i++){
			buf[i] = c = getc(inf);
			if(c == EOF) notcom2t();
		}
		for(;;){ /* TYPE_COMSHPREVȍ~̏ꍇ͒PƂ\r邱Ƃ
			     */
			for(;;){
				if(EOF == (c = getc(inf))) notcom2t();
				if(c == '\n') break;
				if(c == '\r'){
					if(EOF == (c = getc(inf))) notcom2t();
					ungetc(c, inf);
					if(c != '\n') break;
				}
			}
			for(i = 0; i < 2; i++){
				if(buf[i] != (c = getc(inf))){
					if(EOF == c) notcom2t();
					ungetc(c, inf);
					break;
				}
			}
			if(i == 2) break;
		}
		break;
	}

	if(enctype == TYPE_NEWCOMSH){
		for(prevc = i = 0; ; ){ /* prevc͑Oc' '菬ǂ */
			c = getc(inf);
			if(c < '!'){
				prevc = 1; continue;
			}
			if(prevc){
				prevc = 0; continue;
			}
			if(!is_print(c)) notcom2t();
			if(c == '*') break; else if(c > '*') --c;
			c -= '!';

			if(!i++){
				t = (c * 3) & 0xff;
			} else {
				t *= 3;
				putc((t >> 8) + c * 3, otf);
				t &= 0xff;
				if(i == 5) i = 0;
			}
		}
	} else {
		for(i = 0; ; ){
			c = getc(inf);
			switch(enctype){
			case TYPE_COMSHARE: case TYPE_COMSHPREV:
			case TYPE_COMSHOLD:
				if(c != EOF && c < '=') continue;
			}
			if(c == '\n' || c == '\r') continue;
			if(c == ':' || c == '=') break;
			 /* TYPE_COMSHARE, TYPE_COMSHPREV, TYPE_COMSHOLD
			    c == ':'̎͂ɂ͗Ȃ */
			if(!is_print(c)) notcom2t();

			if(enctype == TYPE_ECHOABLE){
				if(c <= '3') c = '`' + '.' - c;
				else if(c <= '9') c = '4' - c;
			}
			c &= 0x3f;

			switch(i++){
			case 0:
				t = c << 2; break;
			case 1:
				putc(t | (c >> 4), otf); t = c << 4; break;
			case 2:
				putc(t | (c >> 2), otf); t = c << 6; break;
			default:
				i = 0;
				putc(t | c, otf); break;
			}
		}
	}
#if 0 /* -c̋tϊlĂ߂ */
	while('\n' == (c = getc(inf)) || '\r' == c);
	if(c != EOF) fputs("Warning: trailing garbage is ignored.\n", stderr);
#endif
}

static	void	notcom2t()
{
	fputs("Input is not seems to be textized by com2txt.\n", stderr);
	exit(1);
}

#ifndef UNIX
void	tscopy(sf, df)
FILE	*sf, *df;
{
	union	REGS	in, out;

	in . x . ax = 0x5700;
	in . x . bx = fileno(sf);
	intdos(&in, &out);
	if(out . x . cflag) return;
	out . x . ax = 0x5701;
	out . x . bx = fileno(df);
	intdos(&out, &in);
}
#endif
